%define releasebase 1
%define VERSION 2.0.30_Linux
# Use this to point to the kernel source, it is distribution dependent
# Add a test for the distribution and 
# for not it is RHEL4 smp
%define KERNEL_SOURCE /usr/src/kernels/2.6.18-194.11.1.el5-x86_64
%define LIB_PATH /lib/modules/2.6.18-194.11.1.el5-x86_64
# Define the install path as well:
%define INSTALL_PATH /usr/gm
# define AFS defines here (only used if "--with afs" is given to rpmbuild):
%define afsarch amd
%define afsroot /afs/cad/hpc

# allow --with[out] <feature> at rpm command line build
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
%{?_with_afs: %{expand: %%define as_afs 1}}
#pick the target
# There is no afs install, but we will tag it as asf if needed
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%if "1" == "%{as_afs}"
%define targetbase afs_%{afsarch}
%else
%define targetbase Limulus
%endif
%endif

# We make two versions, one for the host and one for the nodes.
#default is for host.
# allow --with[out] <feature> at rpm command line build
%define node 0 
%{?_with_node: %{expand: %%define node 1}}

Summary: GM Driver and Utilities 
Name: gm
Version: %{VERSION}
%if "1" == "%{node}"
 %define release node.%{releasebase}.%{targetbase}
%else
 %define release  %{releasebase}.%{targetbase}
%endif
Release: %{release}
License: Myricom, Inc.
Group: %{targetbase}/Libaries
Packager: help@myri.com 
URL: http:://www.myri.com/scs/
#Source: ftp://comrade@ftp.myri.com/pub/GM/gm-2.0.26_Linux_rc20060522134228PDT.tar.gz
Source:  %{name}-%{version}.tar.gz
Prefix: /usr
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}

%description

GM is a message-passing system for Myrinet networks. The GM system 
includes a driver, Myrinet-interface control program, a network
mapping program, and the GM API, library, and header files. GM features 
include:
              Concurrent, protected, user-level access to the Myrinet interface. 
              Reliable, ordered delivery of messages. 
              Automatic mapping and route computation. 
              Automatic recovery from transient network problems. 
              Extensible software, allowing simultaneous direct support of the 
		GM API, pseudo-ethernet (IP), MPI, and other APIs.
              Scalability to thousands of nodes. 
              Very low host-CPU utilization. 

%prep
%setup -n gm-%{VERSION}

%build
export GM_PREFIX=%{INSTALL_PATH}
/bin/rm -f config.cache
sh ./configure --prefix=/usr/gm --with-linux=%{KERNEL_SOURCE} --enable-linux-modversions --enable-new-features --disable-l4
# This probably should be a patch file, but sed will do for now
# Need to promote the gm startup to after netfs for some reason
# warewulf systems.
/bin/cp scripts/etc/init.d/gm scripts/etc/init.d/gm.install
sed "s!chkconfig: 2345 20 80!chkconfig: 2345 30 80!g" scripts/etc/init.d/gm.install > scripts/etc/init.d/gm
/bin/rm scripts/etc/init.d/gm.install


make

%install
mkdir -p $RPM_BUILD_ROOT/%{INSTALL_PATH}

cd binary
./GM_INSTALL $RPM_BUILD_ROOT/%{INSTALL_PATH}
/bin/rm $RPM_BUILD_ROOT/%{INSTALL_PATH}/.gm_install_log_for*   

#if a node, strip the doc and include dirs
%if "1" == "%{node}"
/bin/rm -r $RPM_BUILD_ROOT/%{INSTALL_PATH}/doc
/bin/rm -r $RPM_BUILD_ROOT/%{INSTALL_PATH}/include
%endif
  
# Fix the GM_PREFIX in  /usr/gm/sbin/gm_install_drivers and
# /etc/init.d/gm.install scripts -- seems easier to fix here for now
# rather than digging through build scripts
/bin/cp $RPM_BUILD_ROOT/%{INSTALL_PATH}/sbin/gm_install_drivers $RPM_BUILD_ROOT/%{INSTALL_PATH}/sbin/gm_install_drivers.install
sed "s!$RPM_BUILD_ROOT%{INSTALL_PATH}!%{INSTALL_PATH}!g" $RPM_BUILD_ROOT/%{INSTALL_PATH}/sbin/gm_install_drivers.install >$RPM_BUILD_ROOT/%{INSTALL_PATH}/sbin/gm_install_drivers

/bin/cp $RPM_BUILD_ROOT/%{INSTALL_PATH}/etc/init.d/gm $RPM_BUILD_ROOT/%{INSTALL_PATH}/etc/init.d/gm.install
sed "s!$RPM_BUILD_ROOT%{INSTALL_PATH}!%{INSTALL_PATH}!g" $RPM_BUILD_ROOT/%{INSTALL_PATH}/etc/init.d/gm.install >$RPM_BUILD_ROOT/%{INSTALL_PATH}/etc/init.d/gm
# fix the "modprobe -r gm" lockup hack problem
/bin/cp $RPM_BUILD_ROOT/%{INSTALL_PATH}/etc/init.d/gm $RPM_BUILD_ROOT/%{INSTALL_PATH}/etc/init.d/gm.install
sed "s!gm_do modprobe -r gm!#gm_do modprobe -r gm!g" $RPM_BUILD_ROOT/%{INSTALL_PATH}/etc/init.d/gm.install >$RPM_BUILD_ROOT/%{INSTALL_PATH}/etc/init.d/gm

%clean
rm -rf $RPM_BUILD_ROOT

%post
echo "Installing GM drivers and starting GM and mapper"
export GM_PREFIX=%{INSTALL_PATH}
%{INSTALL_PATH}/sbin/gm_install_drivers
#do not try and start gm when it is installed in the vnfs
%if "0" == "%{node}"
  /etc/rc.d/init.d/gm start
%endif
echo %{INSTALL_PATH}/lib64 >> /etc/ld.so.conf
echo %{INSTALL_PATH}/lib >> /etc/ld.so.conf 
/sbin/ldconfig

#make it happen at boot.
chkconfig --add gm

%postun
# undo gm_install_drivers
%if "0" == "%{node}"
  /etc/rc.d/init.d/gm stop
%endif
chkconfig --del gm
/bin/rm /etc/rc.d/init.d/gm
/bin/rm -r %{LIB_PATH}/gm
/bin/rm -r /etc/dev.d/gm
/bin/rm -f /var/lock/subsys/gm
/bin/rm -r /etc/gm_mapper
for i in 0 1 2 3 4 5 6 7 ; do
  /bin/rm  /dev/gm$i
  /bin/rm /dev/gmp$i
done


%files
%attr(-, root, root) /usr/gm/*

